diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/AUTHORS ns-3.42/AUTHORS
--- ns-3.41/AUTHORS	2024-02-09 14:44:07.717788700 -0800
+++ ns-3.42/AUTHORS	2024-05-29 15:29:46.824072800 -0700
@@ -1,3 +1,4 @@
+Rami Abdallah <abdallah.rami@gmail.com>
 Eduardo Abinader (eduardo.abinader@gmail.com)
 John Abraham (john.abraham.in@gmail.com)
 Danilo Abrignani (dabrignani@gmail.com)
@@ -43,6 +44,7 @@
 Dan Broyles (muxman@sbcglobal.net)
 Jonathan Brugge (j.d.brugge@student.utwente.nl)
 Junling Bu (linlinjavaer@gmail.com)
+Alessio Bugetti (alessiobugetti98@gmail.com)
 Elena Buchatskaia (borovkovaes@iitp.ru)
 Alessio Bugetti (alessiobugetti98@gmail.com)
 Nuno Cardoso (nunopcardoso@gmail.com)
@@ -56,6 +58,7 @@
 Shobhit Chaurasia (000shobhitchaurasia@gmail.com)
 Luciano Jerez Chaves (ljerezchaves@gmail.com)
 Eugene Chemeritskiy (echemeritskiy@arccn.ru)
+Rui Chen (rui@chenrui.dev)
 Yufei Cheng (yfcheng@ittc.ku.edu)
 Aditya Chirania (adityachirania97@gmail.com)
 Zhao Wen Chow (shu@mos.ics.keio.ac.jp)
@@ -136,6 +139,7 @@
 Sourabh Jain (jainsourabh679@gmail.com)
 Vivek Jain (jain.vivek.anand@gmail.com)
 Sam Jansen (sam.jansen@gmail.com)
+Jacob Janzen (jacob.a.s.janzen@gmail.com)
 Chandrakant Jena (chandrakant.barcelona@gmail.com)
 Liu Jian (liujatp@gmail.com)
 Sascha Alexander Jopen (jopen@informatik.uni-bonn.de)
@@ -151,6 +155,7 @@
 Morteza Kheirkhah (m.kheirkhah@sussex.ac.uk)
 Jörg Christian Kirchhof (christian.kirchhof@rwth-aachen.de)
 Ohad Klausner
+Wojtek Kosior (koszko@koszko.org)
 Katarina Koutlia (katerina.koutlia@cttc.es)
 Shravya Ks (shravya.ks0@gmail.com)
 Flavio Kubota (flaviokubota@gmail.com)
@@ -193,6 +198,7 @@
 Jonathan McCrohan (jmccroha@tcd.ie)
 Andrew McGregor (andrewmcgr@gmail.com)
 Miralem Mehic (miralemmehic@gmail.com)
+Zili Meng (zilim@ieee.org)
 Levente Mészáros (levy@omnetpp.org)
 Vedran Miletić (rivanvx@gmail.com)
 Saswat Mishra (clicksaswat@gmail.com)
@@ -270,11 +276,13 @@
 Ali Rostami (a.rostami@rutgers.edu)
 Bill Roome (wdr@bell-labs.com)
 David Rua (david.rua@gmail.com)
+Chan Ruihua (chenrh20@mails.tsinghua.edu.cn)
 Andrea Sacco (andrea.sacco85@gmail.com)
 Richard Sailer (richard_sailer@systemli.org)
 Lynne Salameh (l.salameh@cs.ucl.ac.uk)
 Providence Salumu Munga (Providence.Salumu@gmail.com, Providence.Salumu_Munga@it-sudparis.eu)
 Francisco Javier Sánchez-Roselly (fnavarro@ujaen.es)
+Mattia Sandri (sandrimatt@dei.unipd.it)
 Charitha Sangaraju (charitha29193@gmail.com)
 Siddharth Santurkar (siddharth.santurkar@ieee.org)
 Gaurav Sathe (gaurav.sathe@tcs.com)
@@ -288,6 +296,7 @@
 Tomasz Seweryn (tomasz.seweryn7@gmail.com)
 Dmitrii Shakshin (d.shakshin@gmail.com)
 Kulin Shah (m.kulin@gmail.com)
+Muyuan Shen (shmy315@gmail.com)
 Guowang Shi (shiguowang2007@gmail.com)
 Phillip Sitbon (phillip.sitbon@gmail.com)
 Pedro Silva (pmms@inesctec.pt)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/bindings/python/ns__init__.py ns-3.42/bindings/python/ns__init__.py
--- ns-3.41/bindings/python/ns__init__.py	2024-02-09 14:44:07.721789000 -0800
+++ ns-3.42/bindings/python/ns__init__.py	2024-05-29 15:29:46.832072700 -0700
@@ -82,11 +82,18 @@
         filter(lambda x: x not in SYSTEM_LIBRARY_DIRECTORIES, set(library_search_paths))
     )
 
+    # Exclude injected windows paths in case of WSL
+    # BTW, why Microsoft? Who had this brilliant idea?
+    library_search_paths = list(filter(lambda x: "/mnt/c/" not in x, library_search_paths))
+
     # Search for the core library in the search paths
     libraries = []
     for search_path in library_search_paths:
         if os.path.exists(search_path):
-            libraries += glob.glob("%s/**/*.%s*" % (search_path, LIBRARY_EXTENSION), recursive=True)
+            libraries += glob.glob(
+                "%s/**/*.%s*" % (search_path, LIBRARY_EXTENSION),
+                recursive=not os.path.exists(os.path.join(search_path, "ns3")),
+            )
 
     # Search system library directories (too slow for recursive search)
     for search_path in SYSTEM_LIBRARY_DIRECTORIES:
@@ -238,7 +245,12 @@
     # Should be the case when running from the source directory
     exec(open(lock_file).read(), {}, values)
     suffix = "-" + values["BUILD_PROFILE"] if values["BUILD_PROFILE"] != "release" else ""
-    modules = [module.replace("ns3-", "") for module in values["NS3_ENABLED_MODULES"]]
+    modules = list(
+        map(
+            lambda x: x.replace("ns3-", ""),
+            values["NS3_ENABLED_MODULES"] + values["NS3_ENABLED_CONTRIBUTED_MODULES"],
+        )
+    )
     prefix = values["out_dir"]
     libraries = {
         os.path.splitext(os.path.basename(x))[0]: x for x in os.listdir(os.path.join(prefix, "lib"))
@@ -508,11 +520,6 @@
     # We expose cppyy to consumers of this module as ns.cppyy
     setattr(cppyy.gbl.ns3, "cppyy", cppyy)
 
-    # To maintain compatibility with pybindgen scripts,
-    # we set an attribute per module that just redirects to the upper object
-    for module in modules:
-        setattr(cppyy.gbl.ns3, module.replace("-", "_"), cppyy.gbl.ns3)
-
     # Set up a few tricks
     cppyy.cppdef(
         """
@@ -558,81 +565,6 @@
     )
     setattr(cppyy.gbl.ns3, "LookupByNameFailSafe", cppyy.gbl.LookupByNameFailSafe)
 
-    def CreateObject(className):
-        try:
-            try:
-                func = "CreateObject%s" % re.sub("[<|>]", "_", className)
-                return getattr(cppyy.gbl, func)()
-            except AttributeError:
-                pass
-            try:
-                func = "Create%s" % re.sub("[<|>]", "_", className)
-                return getattr(cppyy.gbl, func)()
-            except AttributeError:
-                pass
-            raise AttributeError
-        except AttributeError:
-            try:
-                func = "CreateObject%s" % re.sub("[<|>]", "_", className)
-                cppyy.cppdef(
-                    """
-                            using namespace ns3;
-                            Ptr<%s> %s(){
-                                Ptr<%s> object = CreateObject<%s>();
-                                return object;
-                            }
-                            """
-                    % (className, func, className, className)
-                )
-            except Exception as e:
-                try:
-                    func = "Create%s" % re.sub("[<|>]", "_", className)
-                    cppyy.cppdef(
-                        """
-                                using namespace ns3;
-                                %s %s(){
-                                    %s object = %s();
-                                    return object;
-                                }
-                                """
-                        % (className, func, className, className)
-                    )
-                except Exception as e:
-                    exit(-1)
-        return getattr(cppyy.gbl, func)()
-
-    setattr(cppyy.gbl.ns3, "CreateObject", CreateObject)
-
-    def GetObject(parentObject, aggregatedObject):
-        # Objects have __cpp_name__ attributes, so parentObject
-        # should not have it while aggregatedObject can
-        if hasattr(parentObject, "__cpp_name__"):
-            raise Exception("Class was passed instead of an instance in parentObject")
-
-        aggregatedIsClass = hasattr(aggregatedObject, "__cpp_name__")
-        aggregatedIsString = type(aggregatedObject) == str
-        aggregatedIsInstance = not aggregatedIsClass and not aggregatedIsString
-
-        if aggregatedIsClass:
-            aggregatedType = aggregatedObject.__cpp_name__
-        if aggregatedIsInstance:
-            aggregatedType = aggregatedObject.__class__.__cpp_name__
-        if aggregatedIsString:
-            aggregatedType = aggregatedObject
-
-        cppyy.cppdef(
-            """using namespace ns3; template <> Ptr<%s> getAggregatedObject<%s>(Ptr<Object> parentPtr, %s param)
-               {
-                    return parentPtr->GetObject<%s>();
-               }
-            """
-            % (aggregatedType, aggregatedType, aggregatedType, aggregatedType)
-        )
-        return cppyy.gbl.getAggregatedObject(
-            parentObject, aggregatedObject if aggregatedIsClass else aggregatedObject.__class__
-        )
-
-    setattr(cppyy.gbl.ns3, "GetObject", GetObject)
     return cppyy.gbl.ns3
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/build-support/custom-modules/ns3-compiler-and-linker-support.cmake ns-3.42/build-support/custom-modules/ns3-compiler-and-linker-support.cmake
--- ns-3.41/build-support/custom-modules/ns3-compiler-and-linker-support.cmake	2024-02-09 14:44:07.721789000 -0800
+++ ns-3.42/build-support/custom-modules/ns3-compiler-and-linker-support.cmake	2024-05-29 15:29:46.832072700 -0700
@@ -47,6 +47,7 @@
 endif()
 
 set(GCC FALSE)
+set(GCC_WORKING_PEDANTIC_SEMICOLON 1)
 if("${CMAKE_CXX_COMPILER_ID}" MATCHES "GNU")
   if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS ${GNU_MinVersion})
     message(
@@ -54,6 +55,26 @@
         "GNU ${CMAKE_CXX_COMPILER_VERSION} ${below_minimum_msg} ${GNU_MinVersion}"
     )
   endif()
+
+  # Check if pedantic throws warning in trailing semicolon after {} scope
+  # (frequently used to make macros look like functions)
+  unset(GCC_WORKING_PEDANTIC_SEMICOLON)
+  include(CheckCXXSourceCompiles)
+  set(CMAKE_REQUIRED_FLAGS "-Wall -Wpedantic -Werror")
+  check_cxx_source_compiles(
+    "
+      int test(){ return 0; };
+      int main(){
+        return test();
+      }
+  "
+    GCC_WORKING_PEDANTIC_SEMICOLON
+  )
+  unset(CMAKE_REQUIRED_FLAGS)
+  if("${GCC_WORKING_PEDANTIC_SEMICOLON}" STREQUAL "")
+    set(GCC_WORKING_PEDANTIC_SEMICOLON 0)
+  endif()
+
   if((CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "12.2.0"))
     # PCH causes weird errors on certain versions of GCC when C++20 is enabled
     # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=106799
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/build-support/custom-modules/ns3-compiler-workarounds.cmake ns-3.42/build-support/custom-modules/ns3-compiler-workarounds.cmake
--- ns-3.41/build-support/custom-modules/ns3-compiler-workarounds.cmake	2024-02-09 14:44:07.721789000 -0800
+++ ns-3.42/build-support/custom-modules/ns3-compiler-workarounds.cmake	2024-05-29 15:29:46.832072700 -0700
@@ -14,31 +14,3 @@
 # Place, Suite 330, Boston, MA  02111-1307 USA
 #
 # Author: Gabriel Ferreira <gabrielcarvfer@gmail.com>
-
-include(CheckCXXSourceCompiles)
-
-# Some compilers (e.g. GCC < 9.1) do not link
-# std::filesystem/std::experimental::filesystem by default. If the sample
-# program can be linked, it means it is indeed linked by default. Otherwise, we
-# link it manually. https://en.cppreference.com/w/cpp/filesystem
-check_cxx_source_compiles(
-  "
-  #ifdef __has_include
-    #if __has_include(<filesystem>)
-      #include <filesystem>
-      namespace fs = std::filesystem;
-    #elif __has_include(<experimental/filesystem>)
-      #include <experimental/filesystem>
-      namespace fs = std::experimental::filesystem;
-    #else
-      #error \"No support for filesystem library\"
-    #endif
-  #endif
-  int main()
-  {
-    std::string path = \"/\";
-    return !fs::exists(path);
-  }
-  "
-  FILESYSTEM_LIBRARY_IS_LINKED
-)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/build-support/custom-modules/ns3-executables.cmake ns-3.42/build-support/custom-modules/ns3-executables.cmake
--- ns-3.41/build-support/custom-modules/ns3-executables.cmake	2024-02-09 14:44:07.725788800 -0800
+++ ns-3.42/build-support/custom-modules/ns3-executables.cmake	2024-05-29 15:29:46.832072700 -0700
@@ -102,15 +102,33 @@
     )
   endif()
 
+  # Check if library is not a ns-3 module library, and if it is, link when
+  # building static or monolib builds
+  set(libraries_to_always_link)
+  set(modules "${libs_to_build};${contrib_libs_to_build}")
+  foreach(lib ${BEXEC_LIBRARIES_TO_LINK})
+    # Remove the lib prefix if one exists
+    set(libless ${lib})
+    string(SUBSTRING "${libless}" 0 3 prefix)
+    if(prefix STREQUAL "lib")
+      string(SUBSTRING "${libless}" 3 -1 libless)
+    endif()
+    # Check if the library is not a ns-3 module
+    if(libless IN_LIST modules)
+      continue()
+    endif()
+    list(APPEND libraries_to_always_link ${lib})
+  endforeach()
+
   if(${NS3_STATIC} AND (NOT BEXEC_STANDALONE))
     target_link_libraries(
-      ${BEXEC_EXECNAME_PREFIX}${BEXEC_EXECNAME} ${LIB_AS_NEEDED_PRE_STATIC}
-      ${lib-ns3-static}
+      ${BEXEC_EXECNAME_PREFIX}${BEXEC_EXECNAME} ${libraries_to_always_link}
+      ${LIB_AS_NEEDED_PRE_STATIC} ${lib-ns3-static}
     )
   elseif(${NS3_MONOLIB} AND (NOT BEXEC_STANDALONE))
     target_link_libraries(
-      ${BEXEC_EXECNAME_PREFIX}${BEXEC_EXECNAME} ${LIB_AS_NEEDED_PRE}
-      ${lib-ns3-monolib} ${LIB_AS_NEEDED_POST}
+      ${BEXEC_EXECNAME_PREFIX}${BEXEC_EXECNAME} ${libraries_to_always_link}
+      ${LIB_AS_NEEDED_PRE} ${lib-ns3-monolib} ${LIB_AS_NEEDED_POST}
     )
   else()
     target_link_libraries(
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/build-support/custom-modules/ns3-fetch-optional-modules-dependencies.cmake ns-3.42/build-support/custom-modules/ns3-fetch-optional-modules-dependencies.cmake
--- ns-3.41/build-support/custom-modules/ns3-fetch-optional-modules-dependencies.cmake	2024-02-09 14:44:07.725788800 -0800
+++ ns-3.42/build-support/custom-modules/ns3-fetch-optional-modules-dependencies.cmake	2024-05-29 15:29:46.832072700 -0700
@@ -3,7 +3,7 @@
 ExternalProject_Add(
   brite_dep
   GIT_REPOSITORY https://gitlab.com/nsnam/BRITE.git
-  GIT_TAG 29c301e828d2a4f303b3d0c69360c987b02d0745
+  GIT_TAG 2a665ae11740a11afec1b068c2a45f21d901cf55
   PREFIX brite_dep
   BUILD_IN_SOURCE TRUE
   CMAKE_ARGS -DCMAKE_INSTALL_PREFIX=${CMAKE_OUTPUT_DIRECTORY}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/build-support/custom-modules/ns3-module-macros.cmake ns-3.42/build-support/custom-modules/ns3-module-macros.cmake
--- ns-3.41/build-support/custom-modules/ns3-module-macros.cmake	2024-02-09 14:44:07.725788800 -0800
+++ ns-3.42/build-support/custom-modules/ns3-module-macros.cmake	2024-05-29 15:29:46.836073000 -0700
@@ -179,10 +179,6 @@
       )
     endif()
 
-    if(NOT FILESYSTEM_LIBRARY_IS_LINKED)
-      list(APPEND BLIB_LIBRARIES_TO_LINK -lstdc++fs)
-    endif()
-
     # Enable examples as tests suites
     if(${ENABLE_EXAMPLES} AND ${ENABLE_TESTS})
       if(NOT ${XCODE})
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/build-support/macros-and-definitions.cmake ns-3.42/build-support/macros-and-definitions.cmake
--- ns-3.41/build-support/macros-and-definitions.cmake	2024-02-09 14:44:07.725788800 -0800
+++ ns-3.42/build-support/macros-and-definitions.cmake	2024-05-29 15:29:46.836073000 -0700
@@ -159,6 +159,21 @@
                                                         STREQUAL "default"
   )
     set(cmakeBuildType relwithdebinfo)
+    # Do not use optimized for size builds on MacOS See issue #1065:
+    # https://gitlab.com/nsnam/ns-3-dev/-/issues/1065
+    if(NOT (DEFINED APPLE))
+      string(REPLACE "-O2" "-Os" CMAKE_CXX_FLAGS_RELWITHDEBINFO
+                     "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}"
+      )
+    endif()
+    # Do not use -Os for gcc 9 default builds due to a bug in gcc that can
+    # result  in extreme memory usage. See MR !1955
+    # https://gitlab.com/nsnam/ns-3-dev/-/merge_requests/1955
+    if(GCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "10.0.0")
+      string(REPLACE "-Os" "-O2" CMAKE_CXX_FLAGS_RELWITHDEBINFO
+                     "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}"
+      )
+    endif()
     set(CMAKE_CXX_FLAGS_DEFAULT ${CMAKE_CXX_FLAGS_RELWITHDEBINFO})
     add_definitions(-DNS3_BUILD_PROFILE_DEBUG)
   elseif(${cmakeBuildType} STREQUAL "release")
@@ -214,6 +229,9 @@
       endif()
     else()
       add_compile_options(-Wall) # -Wextra
+      if(${GCC_WORKING_PEDANTIC_SEMICOLON})
+        add_compile_options(-Wpedantic)
+      endif()
       if(${NS3_WARNINGS_AS_ERRORS})
         add_compile_options(-Werror -Wno-error=deprecated-declarations)
       endif()
@@ -371,7 +389,9 @@
   endif()
 
   if(${NS3_SANITIZE})
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address,leak,undefined")
+    set(CMAKE_CXX_FLAGS
+        "${CMAKE_CXX_FLAGS} -fsanitize=address,leak,undefined -fno-sanitize-recover=all"
+    )
   endif()
 
   if(${NS3_SANITIZE_MEMORY})
@@ -572,6 +592,7 @@
     endif()
   endif()
 
+  set(LIBXML2_FOUND FALSE)
   if(${NS3_STATIC})
     # Warn users that they may be using shared libraries, which won't produce a
     # standalone static library
@@ -965,7 +986,7 @@
   # return variable
   check_deps(
     sphinx_docs_missing_deps CMAKE_PACKAGES Sphinx
-    EXECUTABLES epstopdf pdflatex latexmk convert dvipng
+    EXECUTABLES epstopdf pdflatex latexmk convert dvipng dia
   )
   if(sphinx_docs_missing_deps)
     message(
@@ -1246,19 +1267,26 @@
         <cstdlib>
         <cstring>
         <exception>
+        <deque>
         <fstream>
+        <functional>
         <iostream>
         <limits>
         <list>
         <map>
         <math.h>
         <ostream>
+        <queue>
         <set>
         <sstream>
         <stdint.h>
         <stdlib.h>
         <string>
+        <tuple>
+        <typeinfo>
+        <type_traits>
         <unordered_map>
+        <utility>
         <vector>
     )
     add_library(
@@ -1269,7 +1297,11 @@
       stdlib_pch${build_profile_suffix} PUBLIC
       "${precompiled_header_libraries}"
     )
-    add_library(stdlib_pch ALIAS stdlib_pch${build_profile_suffix})
+
+    # Alias may collide with actual pch in builds without suffix (e.g. release)
+    if(NOT TARGET stdlib_pch)
+      add_library(stdlib_pch ALIAS stdlib_pch${build_profile_suffix})
+    endif()
 
     add_executable(
       stdlib_pch_exec ${PROJECT_SOURCE_DIR}/build-support/empty-main.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/.clang-tidy ns-3.42/.clang-tidy
--- ns-3.41/.clang-tidy	2024-02-09 14:44:07.717788700 -0800
+++ ns-3.42/.clang-tidy	2024-05-29 15:29:46.824072800 -0700
@@ -2,6 +2,7 @@
   -*,
   bugprone-argument-comment,
   bugprone-bool-pointer-implicit-conversion,
+  bugprone-branch-clone,
   bugprone-inaccurate-erase,
   bugprone-move-forwarding-reference,
   bugprone-redundant-branch-condition,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/CMakeLists.txt ns-3.42/CMakeLists.txt
--- ns-3.41/CMakeLists.txt	2024-02-09 14:44:07.721789000 -0800
+++ ns-3.42/CMakeLists.txt	2024-05-29 15:29:46.828072800 -0700
@@ -13,7 +13,7 @@
 # minimum compiler versions
 set(AppleClang_MinVersion 11.0.0)
 set(Clang_MinVersion 10.0.0)
-set(GNU_MinVersion 9.0.0)
+set(GNU_MinVersion 9.1.0)
 
 # common options
 option(NS3_ASSERT "Enable assert on failure" OFF)
@@ -107,21 +107,6 @@
       "List of modules that should have their examples and tests built (e.g. lte;wifi)"
 )
 
-if(${NS3_CCACHE})
-  # Use ccache if available
-  mark_as_advanced(CCACHE)
-  find_program(CCACHE ccache)
-  if(NOT ("${CCACHE}" STREQUAL "CCACHE-NOTFOUND"))
-    message(STATUS "CCache is enabled.")
-    set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE})
-    execute_process(
-      COMMAND
-        ${CCACHE} --set-config
-        sloppiness=pch_defines,time_macros,include_file_mtime,include_file_ctime
-    )
-  endif()
-endif()
-
 # Include macros used below
 include(build-support/macros-and-definitions.cmake)
 
@@ -143,6 +128,21 @@
   ns3rc_enabled_modules ns3rc_disabled_modules
 )
 
+if(${NS3_CCACHE})
+  # Use ccache if available
+  mark_as_advanced(CCACHE)
+  find_program(CCACHE ccache)
+  if(NOT ("${CCACHE}" STREQUAL "CCACHE-NOTFOUND"))
+    message(STATUS "CCache is enabled.")
+    set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE})
+    execute_process(
+      COMMAND
+        ${CCACHE} --set-config
+        sloppiness=pch_defines,time_macros,include_file_mtime,include_file_ctime
+    )
+  endif()
+endif()
+
 # ##############################################################################
 # Process options                     #
 # ##############################################################################
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/doc/contributing/Makefile ns-3.42/doc/contributing/Makefile
--- ns-3.41/doc/contributing/Makefile	2024-02-09 14:44:07.725788800 -0800
+++ ns-3.42/doc/contributing/Makefile	2024-05-29 15:29:46.836073000 -0700
@@ -2,7 +2,7 @@
 #
 
 # You can set these variables from the command line.
-SPHINXOPTS    =
+SPHINXOPTS    = -W --keep-going
 SPHINXBUILD   = sphinx-build
 PAPER         =
 BUILDDIR      = build
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/doc/doxygen.conf ns-3.42/doc/doxygen.conf
--- ns-3.41/doc/doxygen.conf	2024-02-09 14:44:07.729788800 -0800
+++ ns-3.42/doc/doxygen.conf	2024-05-29 15:29:46.840072900 -0700
@@ -461,7 +461,7 @@
 # the optimal cache size from a speed point of view.
 # Minimum value: 0, maximum value: 9, default value: 0.
 
-LOOKUP_CACHE_SIZE      = 2
+LOOKUP_CACHE_SIZE      = 4
 
 # The NUM_PROC_THREADS specifies the number threads doxygen is allowed to use
 # during processing. When set to 0 doxygen will based this on the number of
@@ -1086,7 +1086,7 @@
 # Fortran comments will always remain visible.
 # The default value is: YES.
 
-STRIP_CODE_COMMENTS    = YES
+STRIP_CODE_COMMENTS    = NO
 
 # If the REFERENCED_BY_RELATION tag is set to YES then for each documented
 # entity all documented functions referencing it will be listed.
@@ -2232,7 +2232,7 @@
 
 ## Allow doxygen to find generated include files, such as ns3/core-config.h
 
-INCLUDE_PATH           = build
+INCLUDE_PATH           = build/include
 
 # You can use the INCLUDE_FILE_PATTERNS tag to specify one or more wildcard
 # patterns (like *.h and *.hpp) to filter out the header-files in the
@@ -2297,7 +2297,11 @@
                          ATTRIBUTE_VALUE_DEFINE_WITH_NAME \
                          ATTRIBUTE_VALUE_IMPLEMENT \
                          ATTRIBUTE_VALUE_IMPLEMENT_WITH_NAME \
-                         NS_UNUSED_GLOBAL
+                         NS_UNUSED_GLOBAL \
+                         NS_DEPRECATED \
+                         NS_DEPRECATED_3_42 \
+                         NS_DEPRECATED_3_41 \
+                         NS_DEPRECATED_3_40
 
 # If the SKIP_FUNCTION_MACROS tag is set to YES then doxygen's preprocessor will
 # remove all references to function-like macros that are alone on a line, have
@@ -2571,7 +2575,7 @@
 # The default value is: png.
 # This tag requires that the tag HAVE_DOT is set to YES.
 
-DOT_IMAGE_FORMAT       = png
+DOT_IMAGE_FORMAT       = SVG
 
 # If DOT_IMAGE_FORMAT is set to svg, then this option can be set to YES to
 # enable generation of interactive SVG images that allow zooming and panning.
@@ -2583,7 +2587,7 @@
 # The default value is: NO.
 # This tag requires that the tag HAVE_DOT is set to YES.
 
-INTERACTIVE_SVG        = NO
+INTERACTIVE_SVG        = YES
 
 # The DOT_PATH tag can be used to specify the path where the dot tool can be
 # found. If left blank, it is assumed the dot tool can be found in the path.
@@ -2694,4 +2698,3 @@
 
 # Disable dark mode in the generated HTML in Doxygen 1.9.6 or greater.
 # HTML_COLORSTYLE        = LIGHT
-
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/doc/doxygen.warnings.report.sh ns-3.42/doc/doxygen.warnings.report.sh
--- ns-3.41/doc/doxygen.warnings.report.sh	2024-02-09 14:44:07.729788800 -0800
+++ ns-3.42/doc/doxygen.warnings.report.sh	2024-05-29 15:29:46.840072900 -0700
@@ -248,10 +248,10 @@
 
 #   Functions with varying numbers of arguments
 #   Explicit template instantiation declaration
-REappend filter_blacklistRE "MakeCallback< ObjectBase \\* >(ObjectBase \\*"
+# REappend filter_blacklistRE "MakeCallback< ObjectBase \\* >(ObjectBase \\*"
 
 #   ATTRIBUTE_HELPER_CPP( and _HEADER(
-REappend filter_blacklistRE "ATTRIBUTE_HELPER_\\(CPP\\|HEADER\\)"
+# REappend filter_blacklistRE "ATTRIBUTE_HELPER_\\(CPP\\|HEADER\\)"
 
 # Filter out regular expression for black list, -e, -t and -F
 filter_outRE=""
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/doc/installation/Makefile ns-3.42/doc/installation/Makefile
--- ns-3.41/doc/installation/Makefile	2024-02-09 14:44:07.729788800 -0800
+++ ns-3.42/doc/installation/Makefile	2024-05-29 15:29:46.840072900 -0700
@@ -2,7 +2,7 @@
 #
 
 # You can set these variables from the command line.
-SPHINXOPTS    =
+SPHINXOPTS    = -W --keep-going
 SPHINXBUILD   = sphinx-build
 PAPER         =
 BUILDDIR      = build
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/doc/manual/Makefile ns-3.42/doc/manual/Makefile
--- ns-3.41/doc/manual/Makefile	2024-02-09 14:44:07.729788800 -0800
+++ ns-3.42/doc/manual/Makefile	2024-05-29 15:29:46.840072900 -0700
@@ -46,6 +46,7 @@
 	source/troubleshoot.rst \
 	source/utilities.rst \
 	source/working-with-cmake.rst \
+	source/working-with-docker.rst \
 	source/working-with-git.rst \
 	source/working-with-gitlab-ci-local.rst \
 	${SRC}/stats/doc/data-collection.rst \
@@ -135,7 +136,7 @@
 	@if test x$($@_width) != x; then $(RESCALE) $($@_width) $@ ; fi
 
 # You can set these variables from the command line.
-SPHINXOPTS    =
+SPHINXOPTS    = -W --keep-going
 SPHINXBUILD   = sphinx-build
 PAPER         =
 BUILDDIR      = build
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/doc/models/Makefile ns-3.42/doc/models/Makefile
--- ns-3.41/doc/models/Makefile	2024-02-09 14:44:07.781789300 -0800
+++ ns-3.42/doc/models/Makefile	2024-05-29 15:29:46.876073000 -0700
@@ -111,6 +111,7 @@
 	figures/testbed.dia \
 	figures/emulated-channel.dia \
 	$(SRC)/antenna/doc/source/figures/antenna-coordinate-system.dia	\
+	$(SRC)/antenna/doc/source/figures/circular-antenna-pattern.png	\
 	$(SRC)/applications/doc/http-embedded-object-size.png \
 	$(SRC)/applications/doc/http-main-object-size.png \
 	$(SRC)/applications/doc/http-num-of-embedded-objects.png \
@@ -141,6 +142,7 @@
 	$(SRC)/wifi/doc/source/figures/PhyEntityHierarchy.dia \
 	$(SRC)/wifi/doc/source/figures/WifiPpduHierarchy.dia \
 	$(SRC)/wifi/doc/source/figures/FemHierarchy.dia \
+	$(SRC)/wifi/doc/source/figures/wifi-phy-rx-trace-helper.dia \
 	$(SRC)/wifi/doc/source/figures/snir.dia \
 	$(SRC)/wifi/doc/source/figures/ack-su-format.pdf \
 	$(SRC)/wifi/doc/source/figures/ack-su-format.png \
@@ -388,6 +390,7 @@
 	$(FIGURES)/PhyEntityHierarchy.eps \
 	$(FIGURES)/WifiPpduHierarchy.eps \
 	$(FIGURES)/FemHierarchy.eps \
+	$(FIGURES)/wifi-phy-rx-trace-helper.eps \
 	$(FIGURES)/snir.eps \
 	$(FIGURES)/WimaxArchitecture.eps \
 	$(FIGURES)/epc-ctrl-arch.eps \
@@ -577,7 +580,7 @@
 	@if test x$($@_width) != x; then $(RESCALE) $($@_width) $@ ; fi
 
 # You can set these variables from the command line.
-SPHINXOPTS    =
+SPHINXOPTS    = -W --keep-going
 SPHINXBUILD   = sphinx-build
 PAPER         =
 BUILDDIR      = build
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/doc/tutorial/Makefile ns-3.42/doc/tutorial/Makefile
--- ns-3.41/doc/tutorial/Makefile	2024-02-09 14:44:07.785789300 -0800
+++ ns-3.42/doc/tutorial/Makefile	2024-05-29 15:29:46.876073000 -0700
@@ -2,7 +2,7 @@
 #
 
 # You can set these variables from the command line.
-SPHINXOPTS    =
+SPHINXOPTS    = -W --keep-going
 SPHINXBUILD   = sphinx-build
 PAPER         =
 BUILDDIR      = build
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/energy/energy-model-example.cc ns-3.42/examples/energy/energy-model-example.cc
--- ns-3.41/examples/energy/energy-model-example.cc	2024-02-09 14:44:07.833789600 -0800
+++ ns-3.42/examples/energy/energy-model-example.cc	2024-05-29 15:29:46.908073000 -0700
@@ -31,6 +31,7 @@
 #include <vector>
 
 using namespace ns3;
+using namespace ns3::energy;
 
 NS_LOG_COMPONENT_DEFINE("EnergyExample");
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/energy/energy-model-with-harvesting-example.cc ns-3.42/examples/energy/energy-model-with-harvesting-example.cc
--- ns-3.41/examples/energy/energy-model-with-harvesting-example.cc	2024-02-09 14:44:07.833789600 -0800
+++ ns-3.42/examples/energy/energy-model-with-harvesting-example.cc	2024-05-29 15:29:46.908073000 -0700
@@ -60,6 +60,7 @@
 #include <vector>
 
 using namespace ns3;
+using namespace ns3::energy;
 
 NS_LOG_COMPONENT_DEFINE("EnergyWithHarvestingExample");
 
